package edu.utexas.cs.surdules.pipes;

import edu.utexas.cs.surdules.pipes.view.ApplicationUI;

import javax.swing.*;

/**
 * @author <A HREF="mailto:razvan.surdulescu@post.harvard.edu">Razvan Surdulescu</A> (c) 2003
 * <BR>
 * You may use and distribute this software for free provided you include
 * this copyright notice. You may not sell this software, use my name for
 * publicity reasons or modify the code without permission from me.
 */
public class Main {
    public static void main(String[] args) {
        String vendor = System.getProperty("java.vendor");
        String version = System.getProperty("java.version");

        if (vendor.indexOf("Sun") == -1 || !version.startsWith("1.3")) {
            JOptionPane.showMessageDialog(null,
                    "Warning: This application has only been tested with Sun JDK 1.3.x\n" +
                    "You seem to be running " + vendor + " " + version + "\n" +
                    "The application may crash or behave incorrectly!",
                    "Java Version Warning",
                    JOptionPane.WARNING_MESSAGE | JOptionPane.OK_OPTION) ;
        }

        // Workaround for bug 4458949 in Java WebStart:
        // http://developer.java.sun.com/developer/bugParade/bugs/4458949.html
        System.setSecurityManager(null);

        ApplicationUI application = new ApplicationUI("Pipes");
        application.setSize(800, 600);
        application.setVisible(true);
    }
}
