package edu.utexas.cs.surdules.pipes.model.forms;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author <A HREF="mailto:razvan.surdulescu@post.harvard.edu">Razvan Surdulescu</A> (c) 2003
 * <BR>
 * You may use and distribute this software for free provided you include
 * this copyright notice. You may not sell this software, use my name for
 * publicity reasons or modify the code without permission from me.
 */
public class PropertiesList {
    private List m_itemsList = new ArrayList();
    private Map m_itemsMap = new HashMap();

    public void addItem(PropertiesItem item) {
        if (m_itemsMap.containsKey(item.getName())) {
            throw new IllegalArgumentException("PropertiesItem '" + item.getName() + "' already exists");
        }
        m_itemsMap.put(item.getName(), item);
        m_itemsList.add(item);
    }

    public PropertiesItem getItem(int index) {
        return (PropertiesItem) m_itemsList.get(index);
    }

    public PropertiesItem getItem(String name) {
        if (!m_itemsMap.containsKey(name)) {
            throw new IllegalArgumentException("PropertiesItem '" + name + "' does not exist");
        }
        return (PropertiesItem) m_itemsMap.get(name);
    }

    public int getCount() {
        return m_itemsList.size();
    }
}
