package edu.utexas.cs.surdules.pipes.model.io;

import edu.utexas.cs.surdules.pipes.model.Arc;
import edu.utexas.cs.surdules.pipes.model.Connector;
import edu.utexas.cs.surdules.pipes.model.Model;
import edu.utexas.cs.surdules.pipes.model.widgets.WidgetAllocate;
import edu.utexas.cs.surdules.pipes.model.widgets.WidgetDelay;
import edu.utexas.cs.surdules.pipes.model.widgets.WidgetRelease;
import edu.utexas.cs.surdules.pipes.model.widgets.WidgetResource;
import edu.utexas.cs.surdules.pipes.model.widgets.WidgetService;
import edu.utexas.cs.surdules.pipes.model.widgets.WidgetSink;
import edu.utexas.cs.surdules.pipes.model.widgets.WidgetSource;

/**
 * @author <A HREF="mailto:razvan.surdulescu@post.harvard.edu">Razvan Surdulescu</A> (c) 2003
 * <BR>
 * You may use and distribute this software for free provided you include
 * this copyright notice. You may not sell this software, use my name for
 * publicity reasons or modify the code without permission from me.
 */
public interface Visitor {
    public void visitModel(Model model);

    public void visitWidgetAllocate(WidgetAllocate widget);

    public void visitWidgetDelay(WidgetDelay widget);

    public void visitWidgetRelease(WidgetRelease widget);

    public void visitWidgetResource(WidgetResource widget);

    public void visitWidgetService(WidgetService widget);

    public void visitWidgetSink(WidgetSink widget);

    public void visitWidgetSource(WidgetSource widget);

    public void visitConnector(Connector connector);

    public void visitArc(Arc arc);
}
