package edu.utexas.cs.surdules.pipes.model.statistics;

import edu.utexas.cs.surdules.pipes.model.simulate.Event;

/**
 * @author <A HREF="mailto:razvan.surdulescu@post.harvard.edu">Razvan Surdulescu</A> (c) 2003
 * <BR>
 * You may use and distribute this software for free provided you include
 * this copyright notice. You may not sell this software, use my name for
 * publicity reasons or modify the code without permission from me.
 */
public class ArrivalRateStatlet implements Statlet {
    double m_end;
    int m_count;

    public String getName() {
        return "Arrival Rate";
    }

    public void onStart() {
        m_end = 0;
        m_count = 0;
    }

    public void onCreate(Event event) {
        // nop
    }

    public void onArrive(Event event) {
        m_count++;
    }

    public void onLeave(Event event) {
        // nop
    }

    public void onEnqueue(Event event) {
        // nop
    }

    public void onDequeue(Event event) {
        // nop
    }

    public void onWork(Event event, double length) {
        // nop
    }

    public void onDestroy(Event event) {
        // nop
    }

    public void onEnd(double time) {
        m_end = time;
    }

    public double getResult() {
        return (m_end == 0 ? Double.NaN : (m_count / m_end));
    }

    public String toString() {
        return "ArrivalRateStatlet: count=" + m_count + ",end=" + m_end + ",average=" + getResult();
    }
}
