package edu.utexas.cs.surdules.pipes.model.statistics;

import edu.utexas.cs.surdules.pipes.model.simulate.Event;

/**
 * @author <A HREF="mailto:razvan.surdulescu@post.harvard.edu">Razvan Surdulescu</A> (c) 2003
 * <BR>
 * You may use and distribute this software for free provided you include
 * this copyright notice. You may not sell this software, use my name for
 * publicity reasons or modify the code without permission from me.
 */
public interface Statlet {
    public String getName();

    public void onStart();

    public void onCreate(Event event);

    public void onArrive(Event event);

    public void onLeave(Event event);

    public void onEnqueue(Event event);

    public void onDequeue(Event event);

    public void onWork(Event event, double length);

    public void onDestroy(Event event);

    public void onEnd(double time);

    public double getResult();
}
