package edu.utexas.cs.surdules.pipes.model.statistics;

import java.util.Arrays;
import java.util.List;

/**
 * @author <A HREF="mailto:razvan.surdulescu@post.harvard.edu">Razvan Surdulescu</A> (c) 2003
 * <BR>
 * You may use and distribute this software for free provided you include
 * this copyright notice. You may not sell this software, use my name for
 * publicity reasons or modify the code without permission from me.
 */
public class StatletFactory {
    public static final String ARRIVALRATE = "Arrival Rate";
    public static final String POPULATION = "Population";
    public static final String QUEUEPOPULATION = "Queue Population";
    public static final String UTILIZATION = "Utilization";
    public static final String RESPONSERATE = "Response Rate";
    public static final String RESPONSETIME = "Response Time";

    private static final String[] STATLET_NAMES = new String[]{
        ARRIVALRATE, POPULATION, QUEUEPOPULATION, UTILIZATION, RESPONSERATE, RESPONSETIME
    };

    public static int getStatletCount() {
        return STATLET_NAMES.length;
    }

    public static List getStatletNames() {
        return Arrays.asList(STATLET_NAMES);
    }

    public static Statlet createStatlet(String name) {
        if (name.equals(ARRIVALRATE)) {
            return new ArrivalRateStatlet();
        } else if (name.equals(POPULATION)) {
            return new PopulationStatlet();
        } else if (name.equals(QUEUEPOPULATION)) {
            return new QueuePopulationStatlet();
        } else if (name.equals(UTILIZATION)) {
            return new UtilizationStatlet();
        } else if (name.equals(RESPONSERATE)) {
            return new ResponseRateStatlet();
        } else if (name.equals(RESPONSETIME)) {
            return new ResponseTimeStatlet();
        } else {
            throw new IllegalArgumentException("Statistic '" + name + "' not recognized");
        }
    }
}
