package edu.utexas.cs.surdules.pipes.view;

import javax.swing.ImageIcon;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.net.URL;

/**
 * @author <A HREF="mailto:razvan.surdulescu@post.harvard.edu">Razvan Surdulescu</A> (c) 2003
 * <BR>
 * You may use and distribute this software for free provided you include
 * this copyright notice. You may not sell this software, use my name for
 * publicity reasons or modify the code without permission from me.
 */
public class ImageIconFlip extends ImageIcon {
    private boolean m_flip;

    public ImageIconFlip(URL url) {
        super(url);
    }

    public boolean isFlipped() {
        return m_flip;
    }

    public void flip() {
        m_flip = !m_flip;
    }

    public synchronized void paintIcon(Component c, Graphics g, int x, int y) {
        Graphics2D g2 = (Graphics2D) g;
        AffineTransform saveTransform = g2.getTransform();

        if (m_flip) {
            AffineTransform finalTransform = new AffineTransform();
            finalTransform.concatenate(AffineTransform.getTranslateInstance(getIconWidth(), 0));
            finalTransform.concatenate(AffineTransform.getScaleInstance(-1, 1));

            g2.transform(finalTransform);
        }

        super.paintIcon(c, g2, x, y);

        g2.setTransform(saveTransform);
    }
}
