package edu.utexas.cs.surdules.pipes.view.forms;

import edu.utexas.cs.surdules.pipes.model.forms.PropertiesList;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.JTableHeader;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/**
 * @author <A HREF="mailto:razvan.surdulescu@post.harvard.edu">Razvan Surdulescu</A> (c) 2003
 * <BR>
 * You may use and distribute this software for free provided you include
 * this copyright notice. You may not sell this software, use my name for
 * publicity reasons or modify the code without permission from me.
 */
public class PropertiesForm extends JDialog {
    private boolean m_accept;

    public PropertiesForm(Frame owner, String title, PropertiesList configuration) {
        super(owner, title, true);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                dispose();
            }
        });

        Container contentPane = getContentPane();
        contentPane.setLayout(new BorderLayout());

        JPanel buttons = new JPanel(new FlowLayout(FlowLayout.RIGHT));

        JButton ok = new JButton("OK");
        ok.setToolTipText("Commit values");
        JButton cancel = new JButton("Cancel");
        cancel.setToolTipText("Discard values");

        ok.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                m_accept = true;
                dispose();
            }
        });

        cancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                m_accept = false;
                dispose();
            }
        });

        buttons.add(ok);
        buttons.add(cancel);

        contentPane.add(buttons, BorderLayout.SOUTH);

        JPanel content = new JPanel(new BorderLayout());

        JScrollPane scroll = new JScrollPane(content);
        contentPane.add(scroll, BorderLayout.CENTER);

        JTable table = new PropertiesTable(configuration);
        JTableHeader header = table.getTableHeader();
        header.setReorderingAllowed(false);

        content.add(header, BorderLayout.NORTH);
        content.add(table, BorderLayout.CENTER);

        setLocationRelativeTo(owner);

        pack();
    }

    public boolean isAccepted() {
        return m_accept;
    }
}
