package edu.utexas.cs.surdules.pipes.view.forms;

import edu.utexas.cs.surdules.pipes.model.forms.PropertiesItem;
import edu.utexas.cs.surdules.pipes.model.forms.PropertiesList;

import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.table.TableCellEditor;
import java.awt.Dialog;
import java.util.Iterator;

/**
 * @author <A HREF="mailto:razvan.surdulescu@post.harvard.edu">Razvan Surdulescu</A> (c) 2003
 * <BR>
 * You may use and distribute this software for free provided you include
 * this copyright notice. You may not sell this software, use my name for
 * publicity reasons or modify the code without permission from me.
 */
public class PropertiesTable extends JTable {
    private PropertiesList m_configuration;

    public PropertiesTable(PropertiesList configuration) {
        super(new PropertiesTableModel(configuration));
        m_configuration = configuration;
    }

    public TableCellEditor getCellEditor(int row, int column) {
        if (column == 0) {
            return super.getCellEditor(row, column);
        } else {
            PropertiesItem item = m_configuration.getItem(row);
            if (item.isMultiValued()) {
                JComboBox comboBox = new JComboBox();
                for (Iterator iter = item.getValues().iterator(); iter.hasNext();) {
                    comboBox.addItem(iter.next());
                }
                return new DefaultCellEditor(comboBox);
            } else {
                return super.getCellEditor(row, column);
            }
        }
    }

    public void setValueAt(Object aValue, int row, int column) {
        PropertiesItem item = m_configuration.getItem(row);
        if (item.isMultiValued()) {
            if (aValue.equals(PropertiesItem.CREATENEW)) {

                TextForm text = new TextForm((Dialog) SwingUtilities.getWindowAncestor(this), "Create New Category");
                text.show();

                if (text.isAccepted()) {
                    aValue = text.getText();
                    item.getValues().add(item.getValues().size() - 1, aValue);
                    repaint();
                } else {
                    aValue = getValueAt(row, column);
                }
            }
        }

        try {
            super.setValueAt(aValue, row, column);
        } catch (IllegalArgumentException iae) {
            JOptionPane.showMessageDialog(this, iae.getMessage(), "Error", JOptionPane.OK_OPTION | JOptionPane.ERROR_MESSAGE);
        }
    }
}
