package edu.utexas.cs.surdules.pipes.view.forms;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author <A HREF="mailto:razvan.surdulescu@post.harvard.edu">Razvan Surdulescu</A> (c) 2003
 * <BR>
 * You may use and distribute this software for free provided you include
 * this copyright notice. You may not sell this software, use my name for
 * publicity reasons or modify the code without permission from me.
 */
public class TextForm extends JDialog {
    private boolean m_accept;
    private String m_text;

    public TextForm(Dialog owner, String name) {
        super(owner, name, true);

        Container contentPane = getContentPane();
        contentPane.setLayout(new BorderLayout());

        JPanel data = new JPanel(new BorderLayout());

        final JTextField text = new JTextField(20);

        JLabel label = new JLabel("Enter new category name:");
        label.setLabelFor(text);

        data.add(label, BorderLayout.NORTH);
        data.add(text, BorderLayout.CENTER);

        JPanel buttons = new JPanel(new FlowLayout(FlowLayout.RIGHT));

        JButton ok = new JButton("OK");
        ok.setToolTipText("Commit value");
        ok.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                m_accept = true;
                m_text = text.getText();
                dispose();
            }
        });

        JButton cancel = new JButton("Cancel");
        cancel.setToolTipText("Discard value");
        cancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                m_accept = false;
                dispose();
            }
        });

        buttons.add(ok);
        buttons.add(cancel);

        contentPane.add(buttons, BorderLayout.SOUTH);
        contentPane.add(data, BorderLayout.CENTER);

        setLocationRelativeTo(owner);

        pack();
    }

    public boolean isAccepted() {
        return m_accept;
    }

    public String getText() {
        return m_text;
    }
}
